Package com.complexible.common.collect

# Interface BufferList<T>

All Superinterfaces:
  `Collection<T>`, `Iterable<T>`

All Known Subinterfaces:
  `ExtendedBufferList<T>`

public interface BufferList<T> extends Collection<T>

Since:
  3.0
Version:
  3.0
Author:
  Evren Sirin

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(T stmt)`
  Adds an element to this buffer list.
  `default boolean`
  `addAll(BufferList<T> buffer)`
  `boolean`
  `addAll(BufferList<T> buffer, int fromIndex, int length)`
  Adds the contents of another buffer list to this one.
  `<E extends T>
  E[]`
  `array()`
  Returns the array which stores the contents of this buffer list.
  `int`
  `capacity()`
  `void`
  `clear()`
  `T`
  `getAt(int index)`
  `boolean`
  `isEmpty()`
  `boolean`
  `isFull()`
  `com.google.common.collect.PeekingIterator<T>`
  `iterator()`
  `int`
  `size()`
  Returns the actual number of elements in the buffer list.
  `BufferList<T>`
  `sort(Comparator<? super T> theComparator)`
  `void`
  `truncate(int size)`

  ### Methods inherited from interface java.util.Collection

  `addAll, contains, containsAll, equals, hashCode, parallelStream, remove, removeAll, removeIf, retainAll, spliterator, stream, toArray, toArray, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

- ## Method Details

  - ### add

    boolean add(T stmt)
    Adds an element to this buffer list.
    Specified by:
      `add` in interface `Collection<T>`
    Parameters:
      `stmt` -
    Returns:
      true if the buffer list reached its maximum capacity

  - ### addAll

    boolean addAll(BufferList<T> buffer, int fromIndex, int length)
    Adds the contents of another buffer list to this one.
    Parameters:
      `buffer` - the other buffer list
      `fromIndex` - the index in the other buffer list to start adding from (inclusive)
      `length` - the number of elements to add
    Returns:
      true if the buffer list reached its maximum capacity

  - ### addAll

    default boolean addAll(BufferList<T> buffer)

  - ### isEmpty

    boolean isEmpty()
    Specified by:
      `isEmpty` in interface `Collection<T>`

  - ### isFull

    boolean isFull()

  - ### iterator

    @Nonnull com.google.common.collect.PeekingIterator<T> iterator()
    Specified by:
      `iterator` in interface `Collection<T>`
    Specified by:
      `iterator` in interface `Iterable<T>`

  - ### clear

    void clear()
    Specified by:
      `clear` in interface `Collection<T>`

  - ### truncate

    void truncate(int size)

  - ### array

    <E extends T> E[] array()
    Returns the array which stores the contents of this buffer list. Length of the array can be greater than the number of stored elements.
    Returns:

  - ### size

    int size()
    Returns the actual number of elements in the buffer list.
    Specified by:
      `size` in interface `Collection<T>`
    Returns:

  - ### capacity

    int capacity()

  - ### sort

    BufferList<T> sort(Comparator<? super T> theComparator)

  - ### getAt

    T getAt(int index)